local mana_cost = ModSettingGet("respawn++.backup_mana_cost")
print (tostring(mana_cost))
table.insert( actions,
	{
		id          = "BACKUP",
		name 		= "Backup",
		description = "Saves to your player backup",
		sprite 		= "mods/respawn++/files/actions/backup.png",
		type 		= ACTION_TYPE_OTHER,
		spawn_level                       = "8,9,10",
		spawn_probability                 = "0.005,0.01,0.05",
		price = 1000,
		mana = mana_cost,
		max_uses = 2,
		action 		= function()
			c.fire_rate_wait = c.fire_rate_wait + 6
			if(reflecting) then	return end
			if (recursion_level or iteration) ~= nil then return end
			local polytools = dofile_once("mods/respawn++/lib/polytools/polytools.lua")
			local entityID = GetUpdatedEntityID()
			saveX, saveY = EntityGetTransform(entityID)
			ModSettingSet( "respawn++.playersave", polytools.save(entityID))
			ModSettingSet( "respawn++.playerx", saveX)
			ModSettingSet( "respawn++.playery", saveY)
			AddFlagPersistent("respawnplus_saved_player")
		end,
	} 
)
table.insert( actions,
	{
		id          = "BACKUP_CLEAR",
		name 		= "Clear Backup",
		description = "Clears your player backup",
		sprite 		= "mods/respawn++/files/actions/backup_clear.png",
		type 		= ACTION_TYPE_OTHER,
		spawn_level                       = "8,9,10",
		spawn_probability                 = "0.005,0.01,0.05",
		price = 1000,
		mana = mana_cost,
		max_uses = 2,
		action 		= function()
			c.fire_rate_wait = c.fire_rate_wait + 6
			if(reflecting) then	return end
			RemoveFlagPersistent("respawnplus_saved_player")
		end,
	}
)
table.insert( actions,
	{
		id          = "BACKUP_LOAD",
		name 		= "Load Backup",
		description = "Loads from your player backup",
		sprite 		= "mods/respawn++/files/actions/load.png",
		type 		= ACTION_TYPE_OTHER,
		spawn_level                       = "8,9,10",
		spawn_probability                 = "0.005,0.01,0.05",
		price = 1000,
		mana = mana_cost,
		max_uses = 2,
		action 		= function()
			c.fire_rate_wait = c.fire_rate_wait + 6
			if(reflecting) then	return end
			if (recursion_level or iteration) ~= nil then return end
			local polytools = dofile_once("mods/respawn++/lib/polytools/polytools.lua")
			print(tostring(polytools))
			local entityID = GetUpdatedEntityID()
			print(tostring(entityID))
			if(HasFlagPersistent("respawnplus_saved_player")) then
				polytools.load(entityID,ModSettingGet("respawn++.playersave"))
				local x, y = EntityGetTransform( entityID )
				if(ModSettingGet("respawn++.loadlocation") == true) then
					EntityLoad("mods/respawn++/files/teleentity.xml",x,y)
				end
			end
			
			
			--print("X:")
			--print (loadedX)
			--print("Y:")
			--print (loadedY)
			--entityIDnew = GetUpdatedEntityID()
			--print(tostring(entityID))
			--print(tostring(entityIDnew))
			--EntityApplyTransform(entityIDnew,loadedX,loadedY,0,1,1)
		end,
	}
)
